

// Extended Euclidean Algorithm
// Compute gcd of a,b and s, t such that
//   as + bt = gcd
// Assumes a and b positive

// Parrallel assignement of two variables
#define assign_both(a, b, c, d)                                                \
  {                                                                            \
    int tmp = d;                                                               \
    a = c;                                                                     \
    b = tmp;                                                                   \
  }

// C function for extended Euclidean Algorithm
int extended_gcd(int a, int b) {
  int swapped = a < b;
  if (swapped) {
    assign_both(a, b, b, a); // swap variables
  }

  int old_r = a, r = b;
  int old_s = 1, s = 0;
  // int old_t = 0, t = 1;

  while (r != 0) {
    int q = old_r / r;
    assign_both(old_r, r, r, old_r - q * r);
    assign_both(old_s, s, s, old_s - q * s);
  }

  int t = b != 0 ? (old_r - old_s * a) / b : 0;

  if (swapped) {
    assign_both(old_s, t, t, old_s);
  }
  return old_r; // and old_s and t, but we don't have structs or pointers...
}
