// Eulers totient function: number of k in [1:n] such that k is prime with n
// https://en.wikipedia.org/wiki/Euler's_totient_function

int phi(int n) {
  int result = n;
  for (int i = 2; i * i <= n; ++i) {
    if (n % i == 0) {
      while (n % i == 0)
        n /= i;
      result -= result / i;
    }
  }
  if (n > 1)
    result -= result / n;
  return result;
}
