// Paper example, as it can be analysed by TAI
// ===========================================

#define F(x) ((x) * (x) + 1)

void example(int rand) {
  int i = 0, j = 0, z = 0;
  while (z < 125) { // Invariant: i == j, and z even
    j = F(j + z % 2);
    if (F(i) == j && z % 2 == 0) {
      z += 2;
    } else { // Dead code
      i = rand;
      z += 7;
    }
    i = F(i);
  }
}

// Same example, but in a state where it can be compiled by GCC
// ============================================================
// command: gcc -Ofast motivating_example.c -S
// Differences:
// - The final printf is required to ensure the whole loop isn't optimized away
// - Using a rand() function instead of a parameter allows quickly checking
//   the generated assembly for `call rand` to see whether the else branch has
//   been removed

// #include <stdio.h>
// #include <stdlib.h>
//
// #define F(x) ((x) * (x) + 1)
//
// void example() {
//   int i = 0, j = 0, z = 0;
//   while (z < 125) { // Invariant: i == j, and z even
//     j = F(j + z % 2);
//     if (F(i) == j && z % 2 == 0) {
//       z += 2;
//     } else { // Dead code
//       i = rand();
//       z += 7;
//     }
//     i = F(i);
//   }
//   printf("%d %d\n", i, j);
// }
