(**************************************************************************)
(*  This file is part of the TAI abstract interpreter.                    *)
(*                                                                        *)
(*  Copyright (C) 2024                                                    *)
(*    CEA (Commissariat à l'énergie atomique et aux énergies              *)
(*         alternatives)                                                  *)
(*                                                                        *)
(*  You can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file LICENSE).                      *)
(**************************************************************************)

(** Domain products, used to combine abstractions *)

open Sig

(** Simple naive product, runs both analysis in parallel

    Binary operator [*] on the command line *)
module Classical (L : Classical_Domain) (R : Classical_Domain with type relation = L.relation) :
  Classical_Domain with type State.t = L.State.t * R.State.t and type relation = L.relation

(** Product between SSA domains

    Binary operator [*] on the command line (under [Lift] or [LiftGVN]) *)
module SSA (L : SSA_Domain) (R : SSA_Domain) :
  SSA_Domain with type SSA_State.t = L.SSA_State.t * R.SSA_State.t
